﻿
#Область ОбработчикиСобытийФормы

&НаСервере
Процедура ПриСозданииНаСервере(Отказ, СтандартнаяОбработка)
	
	массивСсылок = ОбщегоНазначения.ХранилищеОбщихНастроекЗагрузить("Тесты_ПодготовкаЗаказовКлиентов", "ЗаказыКлиентов", Новый Массив);
	
	ЗаказыКлиентов.ЗагрузитьЗначения(массивСсылок);
	
КонецПроцедуры

#КонецОбласти

#Область ОбработчикиКомандФормы

&НаКлиенте
Процедура Подготовить(Команда)
	
	ПодготовитьНаСервере();
	
КонецПроцедуры

&НаКлиенте
Процедура СохранитьВCSV(Команда)
	
	ПараметрыСохраненияФайла = ФайловаяСистемаКлиент.ПараметрыСохраненияФайла();
	ПараметрыСохраненияФайла.Диалог.Фильтр = НСтр("ru = 'Выгруженные заказы'") + "(*.csv)|*.csv";
	ФайловаяСистемаКлиент.СохранитьФайл(Неопределено, ДанныеФайлаCSV(), "Заказы.csv", ПараметрыСохраненияФайла);
	
КонецПроцедуры

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

&НаСервере
Процедура ПодготовитьНаСервере()
	
	ОбщегоНазначения.ХранилищеОбщихНастроекСохранить("Тесты_ПодготовкаЗаказовКлиентов", "ЗаказыКлиентов", ЗаказыКлиентов.ВыгрузитьЗначения());
	
	тзЗаказы = ТаблицаЗаказовКлиента();
	
	ЗаполнитьТабличныйДокумент_ЗаказыКлиентов(тзЗаказы);
	СохранитьСсылкиВДжсон_ЗаказыКлиентов(тзЗаказы);
	
КонецПроцедуры

&НаСервере
Процедура ЗаполнитьТабличныйДокумент_ЗаказыКлиентов(тзЗаказы)
	
	Макет = РеквизитФормыВЗначение("Объект").ПолучитьМакет("ТабличныйДокумент");
	
	ОбластьШапкаТаблицы     = Макет.ПолучитьОбласть("ШапкаТаблицы");
	ОбластьДетальныхЗаписей = Макет.ПолучитьОбласть("Детали");
	
	ТабличныйДокумент.Очистить();
	ТабличныйДокумент.Вывести(ОбластьШапкаТаблицы);
	
	Для каждого цСтрокаЗаказа Из тзЗаказы Цикл
		
		ОбластьДетальныхЗаписей.Параметры.Заполнить(цСтрокаЗаказа);
		ТабличныйДокумент.Вывести(ОбластьДетальныхЗаписей);
		
	КонецЦикла;
	
КонецПроцедуры

&НаСервере
Функция ТаблицаЗаказовКлиента()
	
	Запрос = Новый Запрос;
	Запрос.Текст =
		"ВЫБРАТЬ
		|	ЗаказКлиентаТовары.Ссылка.Организация КАК Организация,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Ссылка.Организация) КАК ОрганизацияПредставление,
		|	ЗаказКлиентаТовары.Ссылка.Подразделение КАК Подразделение,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Ссылка.Подразделение) КАК ПодразделениеПредставление,
		|	ЗаказКлиентаТовары.Ссылка.Контрагент КАК Контрагент,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Ссылка.Контрагент) КАК КонтрагентПредставление,
		|	ЗаказКлиентаТовары.Ссылка.Соглашение КАК Соглашение,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Ссылка.Соглашение) КАК СоглашениеПредставление,
		|	ЗаказКлиентаТовары.Ссылка.ТочкаДоставки КАК ТочкаДоставки,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Ссылка.ТочкаДоставки) КАК ТочкаДоставкиПредставление,
		|	ЗаказКлиентаТовары.Ссылка.Дата КАК Дата,
		|	ЗаказКлиентаТовары.Номенклатура КАК Номенклатура,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Номенклатура) КАК НоменклатураПредставление,
		|	ЗаказКлиентаТовары.Номенклатура.Артикул КАК НоменклатураАртикул,
		|	ЗаказКлиентаТовары.Номенклатура.Код КАК НоменклатураКод,
		|	ЗаказКлиентаТовары.Характеристика КАК Характеристика,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Характеристика) КАК ХарактеристикаПредставление,
		|	ЗаказКлиентаТовары.Упаковка КАК Упаковка,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Упаковка) КАК УпаковкаПредставление,
		|	ЗаказКлиентаТовары.Количество КАК Количество,
		|	ЗаказКлиентаТовары.Цена КАК Цена,
		|	ЗаказКлиентаТовары.СтавкаНДС КАК СтавкаНДС,
		|	ЗаказКлиентаТовары.Склад КАК Склад,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Склад) КАК СкладПредставление,
		|	ЗаказКлиентаТовары.Ссылка.ДатаОтгрузки КАК ДатаОтгрузки,
		|	ЗаказКлиентаТовары.Ссылка.ДатаДоставки КАК ДатаДоставки,
		|	ЗаказКлиентаТовары.Ссылка.Ответственный КАК Ответственный,
		|	ПРЕДСТАВЛЕНИЕ(ЗаказКлиентаТовары.Ссылка.Ответственный) КАК ОтветственныйПредставление,
		|	ЗаказКлиентаТовары.Ссылка.Комментарий КАК Комментарий,
		|	ЗаказКлиентаТовары.Ссылка.НомерПоДаннымКлиента КАК НомерПоДаннымКлиента,
		|	ЗаказКлиентаТовары.Ссылка.ДатаПоДаннымКлиента КАК ДатаПоДаннымКлиента
		|ИЗ
		|	Документ.ЗаказКлиента.Товары КАК ЗаказКлиентаТовары
		|ГДЕ
		|	ЗаказКлиентаТовары.Ссылка В(&Заказы)";
	
	Запрос.УстановитьПараметр("Заказы", ЗаказыКлиентов.ВыгрузитьЗначения());
	
	тзЗаказы = Запрос.Выполнить().Выгрузить();
	
	Возврат тзЗаказы;
	
КонецФункции

&НаСервере
Процедура СохранитьСсылкиВДжсон_ЗаказыКлиентов(тзЗаказы)
	
	массивСсылок = Новый Массив;
	
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(массивСсылок, тзЗаказы.ВыгрузитьКолонку("Организация"));
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(массивСсылок, тзЗаказы.ВыгрузитьКолонку("Подразделение"));
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(массивСсылок, тзЗаказы.ВыгрузитьКолонку("Контрагент"));
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(массивСсылок, тзЗаказы.ВыгрузитьКолонку("Соглашение"));
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(массивСсылок, тзЗаказы.ВыгрузитьКолонку("ТочкаДоставки"));
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(массивСсылок, тзЗаказы.ВыгрузитьКолонку("Упаковка"));
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(массивСсылок, тзЗаказы.ВыгрузитьКолонку("Склад"));
	
	подобранныеСпецификации = Новый Массив;
	подобраннаяНоменклатура = тзЗаказы.ВыгрузитьКолонку("Номенклатура");
	ПодобратьСпецификацииПоНоменклатуре(подобраннаяНоменклатура, подобранныеСпецификации, подобраннаяНоменклатура);
	
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(массивСсылок, подобраннаяНоменклатура);
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(массивСсылок, подобранныеСпецификации);
	
	к2КоллекцииКлиентСервер.СвернутьМассив(массивСсылок);
	
	Обработки.к2ОбменСДжсон_Выгрузка.Добавить(массивСсылок);
	
КонецПроцедуры

Процедура ПодобратьСпецификацииПоНоменклатуре(пМассивНоменклатуры, пПодобранныеСпецификации, пПодобраннаяНоменклатура)
	
	Если пМассивНоменклатуры.Количество() = 0 Тогда
		
		Возврат;
		
	КонецЕсли;
	
	Запрос = Новый Запрос;
	Запрос.Текст = "ВЫБРАТЬ
		|	к2РесурсныеСпецификацииВыходныеИзделия.Ссылка КАК Ссылка
		|ПОМЕСТИТЬ втСпецификации
		|ИЗ
		|	Справочник.к2РесурсныеСпецификации.ВыходныеИзделия КАК к2РесурсныеСпецификацииВыходныеИзделия
		|ГДЕ
		|	к2РесурсныеСпецификацииВыходныеИзделия.Номенклатура В(&НоваяНоменклатура)
		|
		|ОБЪЕДИНИТЬ ВСЕ
		|
		|ВЫБРАТЬ
		|	к2РесурсныеСпецификацииВозвратныеОтходы.Ссылка
		|ИЗ
		|	Справочник.к2РесурсныеСпецификации.ВозвратныеОтходы КАК к2РесурсныеСпецификацииВозвратныеОтходы
		|ГДЕ
		|	к2РесурсныеСпецификацииВозвратныеОтходы.Номенклатура В(&НоваяНоменклатура)
		|
		|ОБЪЕДИНИТЬ ВСЕ
		|
		|ВЫБРАТЬ
		|	к2РесурсныеСпецификацииМатериалыИУслуги.Ссылка
		|ИЗ
		|	Справочник.к2РесурсныеСпецификации.МатериалыИУслуги КАК к2РесурсныеСпецификацииМатериалыИУслуги
		|ГДЕ
		|	к2РесурсныеСпецификацииМатериалыИУслуги.Номенклатура В(&НоваяНоменклатура)
		|
		|ОБЪЕДИНИТЬ ВСЕ
		|
		|ВЫБРАТЬ
		|	к2РесурсныеСпецификацииЛом.Ссылка
		|ИЗ
		|	Справочник.к2РесурсныеСпецификации.Лом КАК к2РесурсныеСпецификацииЛом
		|ГДЕ
		|	к2РесурсныеСпецификацииЛом.Номенклатура В(&НоваяНоменклатура)
		|;
		|
		|////////////////////////////////////////////////////////////////////////////////
		|ВЫБРАТЬ РАЗЛИЧНЫЕ
		|	втСпецификации.Ссылка КАК Ссылка
		|ИЗ
		|	втСпецификации КАК втСпецификации
		|ГДЕ
		|	НЕ втСпецификации.Ссылка В (&ПодобранныеСпецификации)
		|;
		|
		|////////////////////////////////////////////////////////////////////////////////
		|ВЫБРАТЬ
		|	ВыходныеИзделия.Номенклатура КАК Номенклатура
		|ИЗ
		|	втСпецификации КАК втСпецификации
		|		ЛЕВОЕ СОЕДИНЕНИЕ Справочник.к2РесурсныеСпецификации.ВыходныеИзделия КАК ВыходныеИзделия
		|		ПО втСпецификации.Ссылка = ВыходныеИзделия.Ссылка
		|ГДЕ
		|	НЕ ВыходныеИзделия.Номенклатура В (&ПодобраннаяНоменклатура)
		|
		|ОБЪЕДИНИТЬ ВСЕ
		|
		|ВЫБРАТЬ
		|	ВозвратныеОтходы.Номенклатура
		|ИЗ
		|	втСпецификации КАК втСпецификации
		|		ЛЕВОЕ СОЕДИНЕНИЕ Справочник.к2РесурсныеСпецификации.ВозвратныеОтходы КАК ВозвратныеОтходы
		|		ПО втСпецификации.Ссылка = ВозвратныеОтходы.Ссылка
		|ГДЕ
		|	НЕ ВозвратныеОтходы.Номенклатура В (&ПодобраннаяНоменклатура)
		|
		|ОБЪЕДИНИТЬ ВСЕ
		|
		|ВЫБРАТЬ
		|	МатериалыИУслуги.Номенклатура
		|ИЗ
		|	втСпецификации КАК втСпецификации
		|		ЛЕВОЕ СОЕДИНЕНИЕ Справочник.к2РесурсныеСпецификации.МатериалыИУслуги КАК МатериалыИУслуги
		|		ПО втСпецификации.Ссылка = МатериалыИУслуги.Ссылка
		|ГДЕ
		|	НЕ МатериалыИУслуги.Номенклатура В (&ПодобраннаяНоменклатура)
		|
		|ОБЪЕДИНИТЬ ВСЕ
		|
		|ВЫБРАТЬ
		|	Лом.Номенклатура
		|ИЗ
		|	втСпецификации КАК втСпецификации
		|		ЛЕВОЕ СОЕДИНЕНИЕ Справочник.к2РесурсныеСпецификации.ВыходныеИзделия КАК Лом
		|		ПО втСпецификации.Ссылка = Лом.Ссылка
		|ГДЕ
		|	НЕ Лом.Номенклатура В (&ПодобраннаяНоменклатура)";
	Запрос.УстановитьПараметр("НоваяНоменклатура", пМассивНоменклатуры);
	Запрос.УстановитьПараметр("ПодобранныеСпецификации", пПодобранныеСпецификации);
	Запрос.УстановитьПараметр("ПодобраннаяНоменклатура", пПодобраннаяНоменклатура);
	
	пакет = Запрос.ВыполнитьПакет();
	
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(пПодобранныеСпецификации, пакет[1].Выгрузить().ВыгрузитьКолонку(0));
	
	новаяНоменклатура = пакет[2].Выгрузить().ВыгрузитьКолонку(0);
	
	к2КоллекцииКлиентСервер.ДобавитьЗначениеВМассив(пПодобраннаяНоменклатура, новаяНоменклатура);
	
	ПодобратьСпецификацииПоНоменклатуре(новаяНоменклатура, пПодобранныеСпецификации, пПодобраннаяНоменклатура);
	
КонецПроцедуры

&НаСервере
Функция ДанныеФайлаCSV()
	
	имяВременногоФайла = ПолучитьИмяВременногоФайла("csv");
	
	Файл = Новый ЗаписьТекста(имяВременногоФайла, КодировкаТекста.UTF8);
	
	ширинаСтраницы = 0;
	перваяКолонка  = 1; // Почему то в 0 и в 1 колонке одно и то же
	перваяСтрока   = 1; // Аналогично дублируется первая строка
	
	Для цНомерКолонки = перваяКолонка По ТабличныйДокумент.ШиринаСтраницы Цикл
		
		текОбласть = ТабличныйДокумент.Область(перваяСтрока, цНомерКолонки, перваяСтрока, цНомерКолонки);
		
		Если Не ЗначениеЗаполнено(текОбласть.Текст) Тогда
			
			ширинаСтраницы = цНомерКолонки - 1;
			Прервать;
			
		КонецЕсли;
		
	КонецЦикла;
	
	Для цНомерСтроки = перваяСтрока По ТабличныйДокумент.ВысотаСтраницы Цикл
		
		текстПервойЯчейки = ТабличныйДокумент.Область(цНомерСтроки, перваяКолонка, цНомерСтроки, перваяКолонка).Текст;
		
		Если Не ЗначениеЗаполнено(текстПервойЯчейки) Тогда
			
			Прервать;
			
		КонецЕсли;
		
		значенияCSV = Новый Массив;
		
		Для цНомерКолонки = перваяКолонка По ширинаСтраницы Цикл
			
			текОбласть = ТабличныйДокумент.Область(цНомерСтроки, цНомерКолонки, цНомерСтроки, цНомерКолонки);
			
			значениеИзТД = текОбласть.Расшифровка;
			
			Если Не ЗначениеЗаполнено(значениеИзТД) Тогда
				
				значениеИзТД = текОбласть.Текст;
				
			КонецЕсли;
			
			значенияCSV.Добавить(ЗначениеCSV(значениеИзТД));
			
		КонецЦикла;
		
		Файл.ЗаписатьСтроку(СтрСоединить(значенияCSV, ";"));
		
	КонецЦикла;
	
	Файл.Закрыть();
	
	ДвоичныеДанные = Новый ДвоичныеДанные(имяВременногоФайла);
	УдалитьФайлы(имяВременногоФайла);
	
	Возврат ПоместитьВоВременноеХранилище(ДвоичныеДанные, УникальныйИдентификатор);
	
КонецФункции

&НаСервере
Функция ЗначениеCSV(ИсходноеЗначение)
	
	ПредставлениеЗначения = "";
	
	Если ТипЗнч(ИсходноеЗначение) = Тип("Строка") Тогда
		
		ПредставлениеЗначения = СокрЛП(ИсходноеЗначение);
		
		Если СтрЧислоСтрок(ПредставлениеЗначения) > 1 ИЛИ СтрНайти(ПредставлениеЗначения, ";") <> 0 Тогда
			
			ПредставлениеЗначения = """" + ПредставлениеЗначения + """";
			
		КонецЕсли;
		
	ИначеЕсли ТипЗнч(ИсходноеЗначение) = Тип("Число") Тогда
		
		ПредставлениеЗначения = Формат(ИсходноеЗначение, "ЧРД=.; ЧН=; ЧГ=0");
		
	ИначеЕсли ТипЗнч(ИсходноеЗначение) = Тип("Дата") Тогда
		
		ПредставлениеЗначения = Формат(ИсходноеЗначение, "ДФ=dd.MM.yyyy");
		
	Иначе
		
		ПредставлениеЗначения = ЗначениеCSV(Строка(ИсходноеЗначение));
		
	КонецЕсли;
	
	Возврат ПредставлениеЗначения;
	
КонецФункции

#КонецОбласти

